import { EventEmitter, OnChanges, OnInit } from '@angular/core';
import { ActionButtonTable } from './models/action-button-table.model';
import { ColumnTable } from './models/column-table.model';
import { RowTable } from './models/row-table.model';
import { CellData } from './models/cell-data.model';
import * as i0 from "@angular/core";
declare class Row {
    data: any;
    actionButtons: ActionButtonTable[];
    collapsedActionButtons: ActionButtonTable[];
}
export declare class NgxAgileTableComponent implements OnInit, OnChanges {
    actionButtons: ActionButtonTable[];
    collapseActionButton: ActionButtonTable;
    columnSettings: ColumnTable[];
    data: any[];
    emptyText: string;
    actionButtonTitle: string;
    searchText: string;
    maxSizeText: string;
    totalElementsText: string;
    paginationPreviousText: string;
    paginationNextText: string;
    paginationPreviousIcon: string;
    paginationNextIcon: string;
    displayGlobalSearchInput: boolean;
    colorVariationLineBreak: number;
    maxActionButtonPerRow: number;
    collapseActionButtonPosition: string;
    height: string;
    totalElements: number;
    totalPages: number;
    elementPerPage: number;
    elementPerPageList: number[];
    enableColumnFiltering: boolean;
    enableColumnSorting: boolean;
    localPagination: boolean;
    onClickActionButton: EventEmitter<ActionButtonTable>;
    onPageChanged: EventEmitter<number>;
    onElementPerPageChanged: EventEmitter<number>;
    onGlobalSearchRequest: EventEmitter<string>;
    onRowDisplayed: EventEmitter<RowTable>;
    pageSelected: number;
    collapseActionButtonPositions: string[];
    pagesRangeLimit: number;
    pageStart: number;
    globalSearchKeywords: string;
    columnSearchKeyword: string;
    columnSearch: ColumnTable;
    columnSortDirectionAsc: boolean;
    columnSort: ColumnTable;
    rows: Row[];
    rowsToDisplay: Row[];
    constructor();
    ngOnInit(): void;
    formatRows(): void;
    ngOnChanges(changes: any): void;
    displayData(): void;
    totalPageCalculation(data?: any[]): void;
    resetTotalPages(data?: any[]): void;
    segmentation(page: number, data?: any[]): Row[];
    pages(): number[];
    onActionButtonClicked(button: ActionButtonTable, index: number): void;
    globalSearchRequest(): void;
    onPageChange(page: number): void;
    onElementPerPageChange(): void;
    filterTable(columnTable: ColumnTable, keyword: string, page?: number): void;
    sortDataDisplay(columnTable: ColumnTable, ascFiltering: boolean, page?: number): void;
    sortByColumn(attr: any, sortColumnDirection: any): void;
    nextPages(): void;
    previousPages(): void;
    tableDataTitleAttribute(data: any, columnTable: ColumnTable): string;
    columnValue(data: any, columnProperty: string, sanitize?: boolean): any;
    cellDataValue(data: any, columnTable: ColumnTable): CellData;
    columnDisplayValue(data: any, columnTable: ColumnTable): any;
    sanitize(value: any): any;
    displayButton(button: ActionButtonTable, index: number): boolean;
    getCollapsePosition(): string;
    getActionButtonToDisplay(data: any): ActionButtonTable[];
    getActionButtonToCollapse(data: any): any;
    rowDisplayed(data: any, nativeElement: any): string;
    getClass(actionButton: ActionButtonTable): string;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgxAgileTableComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgxAgileTableComponent, "ngx-table", never, { "actionButtons": { "alias": "actionButtons"; "required": false; }; "collapseActionButton": { "alias": "collapseActionButton"; "required": false; }; "columnSettings": { "alias": "columnSettings"; "required": false; }; "data": { "alias": "data"; "required": false; }; "emptyText": { "alias": "emptyText"; "required": false; }; "actionButtonTitle": { "alias": "actionButtonTitle"; "required": false; }; "searchText": { "alias": "searchText"; "required": false; }; "maxSizeText": { "alias": "maxSizeText"; "required": false; }; "totalElementsText": { "alias": "totalElementsText"; "required": false; }; "paginationPreviousText": { "alias": "paginationPreviousText"; "required": false; }; "paginationNextText": { "alias": "paginationNextText"; "required": false; }; "paginationPreviousIcon": { "alias": "paginationPreviousIcon"; "required": false; }; "paginationNextIcon": { "alias": "paginationNextIcon"; "required": false; }; "displayGlobalSearchInput": { "alias": "displayGlobalSearchInput"; "required": false; }; "colorVariationLineBreak": { "alias": "colorVariationLineBreak"; "required": false; }; "maxActionButtonPerRow": { "alias": "maxActionButtonPerRow"; "required": false; }; "collapseActionButtonPosition": { "alias": "collapseActionButtonPosition"; "required": false; }; "height": { "alias": "height"; "required": false; }; "totalElements": { "alias": "totalElements"; "required": false; }; "totalPages": { "alias": "totalPages"; "required": false; }; "elementPerPage": { "alias": "elementPerPage"; "required": false; }; "elementPerPageList": { "alias": "elementPerPageList"; "required": false; }; "enableColumnFiltering": { "alias": "enableColumnFiltering"; "required": false; }; "enableColumnSorting": { "alias": "enableColumnSorting"; "required": false; }; "localPagination": { "alias": "localPagination"; "required": false; }; }, { "onClickActionButton": "onClickActionButton"; "onPageChanged": "onPageChanged"; "onElementPerPageChanged": "onElementPerPageChanged"; "onGlobalSearchRequest": "onGlobalSearchRequest"; "onRowDisplayed": "onRowDisplayed"; }, never, never, false, never>;
}
export {};
